<template>
  <base-dialog :show="showDialog" title="Delete comment" @close="closeDialog">
    <template #default>
      <p class="text-neutral-400">
        Are you sure you want to delete this comment? This will remove the
        comment and can't be undone.
      </p>
    </template>
    <template #actions>
      <div class="flex">
        <base-button type="cancel-dialog" @click="closeDialog"
          >No, cancel</base-button
        >
        <base-button type="delete-dialog" @click="confirmDelete"
          >Yes, delete</base-button
        >
      </div>
    </template>
  </base-dialog>
  <base-card class="grid grid--comment">
    <base-vote
      @increase="increase"
      @decrease="decrease"
      class="vote"
      :vote="score"
    ></base-vote>
    <div class="flex header">
      <base-avatar :name="user.image.webp"></base-avatar>
      <h2 class="text-neutral-500 fw-500 name">
        {{ user.username }}
        <base-badge v-if="isOwner" title="you"></base-badge>
      </h2>
      <div class="time">
        <span>{{ timeAgo }}</span>
      </div>
    </div>
    <base-button
      @click="addReplyToComment"
      v-if="!isOwner"
      class="control"
      icon="icon-reply.svg"
      type="reply-with-icon"
      >Reply</base-button
    >
    <div class="flex control" v-else>
      <base-button @click="openDialog" icon="icon-delete.svg" type="delete"
        >Delete</base-button
      >
      <base-button @click="edit" icon="icon-edit.svg" type="edit">{{
        editMode ? "Cancel" : "Edit"
      }}</base-button>
    </div>
    <p v-if="!editMode" class="content">
      <span class="fw-500 text-primary-700" v-if="replyingTo">{{
        replyingToUser
      }}</span>
      {{ content }}
    </p>
    <div class="content" v-else>
      <textarea v-model="newContent"> </textarea>
      <base-button class="update-button" @click="confirmEdit" type="reply"
        >Update</base-button
      >
    </div>
  </base-card>
  <new-comment-reply
    @added="addReplyToComment"
    :comment-id="id"
    :reply-id="replyId"
    v-if="addReply"
  ></new-comment-reply>
  <slot></slot>
</template>

<script>
import NewCommentReply from "./NewCommentReply.vue";

export default {
  components: {
    NewCommentReply,
  },
  props: [
    "id",
    "replyId",
    "content",
    "createdAt",
    "score",
    "user",
    "replyingTo",
  ],
  inject: [
    "increaseScore",
    "decreaseScore",
    "deleteComment",
    "editComment",
    "currentUser",
  ],
  data() {
    return {
      addReply: false,
      showDialog: false,
      editMode: false,
      newContent: this.content,
    };
  },
  computed: {
    replyingToUser() {
      return "@" + this.replyingTo + ", ";
    },
    isOwner() {
      return this.currentUser.username === this.user.username;
    },
    timeAgo() {
      // in miliseconds
      var units = {
        year: 24 * 60 * 60 * 1000 * 365,
        month: (24 * 60 * 60 * 1000 * 365) / 12,
        day: 24 * 60 * 60 * 1000,
        hour: 60 * 60 * 1000,
        minute: 60 * 1000,
        second: 1000,
      };
      var rtf = new Intl.RelativeTimeFormat("en", { numeric: "auto" });
      var elapsed = new Date(this.createdAt) - new Date();

      // "Math.abs" accounts for both "past" & "future" scenarios
      for (var u in units) {
        if (Math.abs(elapsed) > units[u] || u == "second")
          return rtf.format(Math.round(elapsed / units[u]), u);
      }
      return this.createdAt;
    },
  },
  methods: {
    addReplyToComment() {
      this.addReply = !this.addReply;
    },
    edit() {
      this.editMode = !this.editMode;
    },
    confirmEdit() {
      this.editComment(this.id, this.replyId, this.newContent);
      this.edit();
    },
    openDialog() {
      this.showDialog = true;
    },
    closeDialog() {
      this.showDialog = false;
    },
    confirmDelete() {
      this.deleteComment(this.id, this.replyId);
    },
    increase() {
      this.increaseScore(this.id, this.replyId);
    },
    decrease() {
      this.decreaseScore(this.id, this.replyId);
    },
  },
};
</script>

<style scoped>
.grid--comment {
  grid-template-areas:
    "header  header  header"
    "content content content"
    "vote    ......  control";
  grid-template-columns: max-content 1fr max-content;
}

@media (min-width: 47em) {
  .grid--comment {
    grid-template-areas:
      "vote header  .......  control"
      "vote content content  content"
      ".... content content  content"
      ".... content content  content";
  }
}
.header {
  grid-area: header;
}
.content {
  grid-area: content;
}
.vote {
  grid-area: vote;
}

.controls,
.control {
  grid-area: control;
}
.update-button {
  margin-left: auto;
}
</style>
